 /*
 *Driver for the card pcie bridge.

 *Copyright (C) 2019 AVerMedia TECHNOLOGIES, Inc.

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 
#include "g_queue.h"
#include "debug.h"

void init_g_queue(g_queue_t *head)
{
    init_queue(&head->queue);
    head->data=NULL;
}

BOOL_T g_queue_empty(g_queue_t *head)
{
    return queue_empty(&head->queue);
}

void g_queue_add_tail(g_queue_t *new, g_queue_t *head)
{
    if(head->data)
    {
        debug_msg("Invalid g_queue head\n");
        return;
    }
     queue_add_tail(&head->queue,&new->queue);
}
 
void g_queue_del(g_queue_t *entry)
{
    queue_del(&entry->queue);
}

g_queue_t *g_queue_first_entry(g_queue_t *head)
{
    g_queue_t *item=queue_first_entry_or_null(&head->queue, g_queue_t, queue);
    
    return item;
}

g_queue_t *g_queue_last_entry(g_queue_t *head)
{
    g_queue_t *item=NULL;
    if(!g_queue_empty(head))
    {
        item=queue_last_entry(&head->queue, g_queue_t, queue);
    }
    return item;
}

g_queue_t *g_queue_next_entry(g_queue_t *item)
{
    g_queue_t *next=queue_next_entry(item,queue);
    
    return next;
}
        

         



