 /*
 *Driver for the card pcie bridge.

 *Copyright (C) 2019 AVerMedia TECHNOLOGIES, Inc.

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef G_QUEUE_H
#define G_QUEUE_H

#ifdef __cplusplus
extern "C" {
#endif
#include "cxt_mgr.h"    
#include "typedef.h"
#include "queue.h"
    
typedef struct
{
    queue_t queue;
    void *data;    
}g_queue_t;


void init_g_queue(g_queue_t *item);
BOOL_T g_queue_empty(g_queue_t *head);
void g_queue_add_tail(g_queue_t *new, g_queue_t *head);
void g_queue_del(g_queue_t *entry);
g_queue_t *g_queue_first_entry(g_queue_t *head);
g_queue_t *g_queue_last_entry(g_queue_t *head);
g_queue_t *g_queue_next_entry(g_queue_t *item);

#define for_each_g_queue_entry(pos, head)                          \
        for (pos = g_queue_first_entry(head);        \
            &pos->queue != (head->queue);                                    \
            pos = g_queue_next_entry(pos))

#define for_each_g_queue_entry_safe(pos, n, head)                  \
        for (pos = g_queue_first_entry(head),        \
            n = g_queue_next_entry(pos);                       \
            &pos->queue != (head->queue);                                    \
            pos = n, n = g_queue_next_entry(pos))    


#ifdef __cplusplus
}
#endif

#endif /* G_QUEUE_H */

