 /*
 *Driver for the debugging.

 *Copyright (C) 2019 AVerMedia TECHNOLOGIES, Inc.

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 
 
#ifndef __TRACE_H__
#define __TRACE_H__

//#include <linux/kobject.h>
#define TRACE_NAME trace

#define TRACE2STR(NAME) MODULE_STR(NAME)
#define TRACE_NAME_STR TRACE2STR(TRACE_NAME)


#define TRACE_CXT_ID fourcc_id('T','R','C','E')


typedef struct 
{
    const char *name;
    unsigned int (*show)(void *cxt, char *buf);
    unsigned int (*store)(void *cxt, const char *buf, unsigned int count);
    void *cxt;
}trace_attr_setup_t;

typedef void *trace_attr_handle_t;

trace_attr_handle_t trace_attr_create(trace_attr_setup_t *);
void trace_attr_free(trace_attr_handle_t attr_handle);
void trace_model_add_attr(void *trace_context,trace_attr_handle_t attr);

void trace_model_update(void *trace_context);
void *trace_model_init(void *cxt_mgr);
void *trace_model_get_handle(void *pcxt_mgr);


#endif
