 /*
 *Driver for the card pcie bridge.

 *Copyright (C) 2019 AVerMedia TECHNOLOGIES, Inc.

 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.

 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.

 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
 

#ifndef V4L2_MODEL_IOCTL_H_
#define V4L2_MODEL_IOCTL_H_

#include <linux/videodev2.h>
#include "typedef.h"
#include "v4l2_model_device.h"

#if 0
/*  Control IDs defined by V4L2 */
#define V4L2_CID_BASE			0x00980900


#define V4L2_CID_BRIGHTNESS		(V4L2_CID_BASE+0)
#define V4L2_CID_CONTRAST		(V4L2_CID_BASE+1)
#define V4L2_CID_SATURATION		(V4L2_CID_BASE+2)
#define V4L2_CID_HUE			(V4L2_CID_BASE+3)
#define V4L2_CID_AUDIO_VOLUME		(V4L2_CID_BASE+5)
#define V4L2_CID_AUDIO_BALANCE		(V4L2_CID_BASE+6)
#define V4L2_CID_AUDIO_BASS		(V4L2_CID_BASE+7)
#define V4L2_CID_AUDIO_TREBLE		(V4L2_CID_BASE+8)
#define V4L2_CID_AUDIO_MUTE		(V4L2_CID_BASE+9)
#define V4L2_CID_AUDIO_LOUDNESS		(V4L2_CID_BASE+10)
#define V4L2_CID_BLACK_LEVEL		(V4L2_CID_BASE+11)
#define V4L2_CID_AUTO_WHITE_BALANCE	(V4L2_CID_BASE+12)
#define V4L2_CID_DO_WHITE_BALANCE	(V4L2_CID_BASE+13)
#define V4L2_CID_RED_BALANCE		(V4L2_CID_BASE+14)
#define V4L2_CID_BLUE_BALANCE		(V4L2_CID_BASE+15)
#define V4L2_CID_GAMMA			(V4L2_CID_BASE+16)
#define V4L2_CID_WHITENESS		(V4L2_CID_GAMMA) /* ? Not sure */
#define V4L2_CID_EXPOSURE		(V4L2_CID_BASE+17)
#define V4L2_CID_AUTOGAIN		(V4L2_CID_BASE+18)
#define V4L2_CID_GAIN			(V4L2_CID_BASE+19)
#define V4L2_CID_HFLIP			(V4L2_CID_BASE+20)
#define V4L2_CID_VFLIP			(V4L2_CID_BASE+21)
#define V4L2_CID_HCENTER		(V4L2_CID_BASE+22)
#define V4L2_CID_VCENTER		(V4L2_CID_BASE+23)
#define V4L2_CID_LASTP1			(V4L2_CID_BASE+24) /* last CID + 1 */
#endif 

int v4l2_model_ioctl_querycap(struct file *file, void *fh, struct v4l2_capability *cap);
int v4l2_model_ioctl_enum_fmt_vid_cap(struct file *file, void *fh, struct v4l2_fmtdesc *f);
int v4l2_model_ioctl_g_fmt_vid_cap(struct file *file, void *fh,struct v4l2_format *f);
int v4l2_model_ioctl_try_fmt_vid_cap(struct file *file, void *fh, struct v4l2_format *f);
int v4l2_model_ioctl_s_fmt_vid_cap(struct file *file, void *fh,struct v4l2_format *f);
int v4l2_model_ioctl_enum_framesizes(struct file *file, void *fh, struct v4l2_frmsizeenum *fsize);
int v4l2_model_ioctl_enum_input(struct file *file, void *fh, struct v4l2_input *inp);
int v4l2_model_ioctl_g_input(struct file *file, void *fh, unsigned int *i);
int v4l2_model_ioctl_s_input(struct file *file, void *fh, unsigned int i);
int v4l2_model_ioctl_enum_frameintervals(struct file *file, void *fh,struct v4l2_frmivalenum *fival);
int v4l2_model_ioctl_g_parm(struct file *file, void *fh,struct v4l2_streamparm *a);
int v4l2_model_ioctl_s_parm(struct file *file, void *fh,struct v4l2_streamparm *a);
int v4l2_model_ioctl_queryctrl(struct file *file, void *fh,struct v4l2_queryctrl *a);
int v4l2_model_ioctl_g_ctrl(struct file *file, void *fh,struct v4l2_control *a);
int v4l2_model_ioctl_s_ctrl(struct file *file, void *fh,struct v4l2_control *a);
int v4l2_model_ioctl_s_customedid(struct file *file, struct edid_data* custom_edid);
int v4l2_model_ioctl_g_customedid(struct file *file, struct edid_data* edid_buf_info);


int v4l2_model_ioctl_cropcap(struct file *file, void *fh,struct v4l2_cropcap *a);
int v4l2_model_ioctl_g_flash(struct file *file, struct v4l2_dump_flash *flash);
int v4l2_model_ioctl_s_flash(struct file *file, struct v4l2_dump_flash *flash);

int v4l2_model_ioctl_g_dv_timings(struct file *file, void *fd,
                                struct v4l2_dv_timings *timings);
int v4l2_model_ioctl_s_dv_timings(struct file *file, void *fd,
                                struct v4l2_dv_timings *timings);

int v4l2_model_ioctl_enum_std(struct file *file, void *fd,
                                struct v4l2_standard *std);

int v4l2_model_ioctl_s_std(struct file *file, void *fd,
            v4l2_std_id std);
int v4l2_model_ioctl_g_std(struct file *file, void *fd,
            v4l2_std_id *std);
int v4l2_model_ioctl_querystd(struct file *file, void *fd,
            v4l2_std_id *std);

int v4l2_model_g_tuner(struct file *file, void *fd,
            struct v4l2_tuner *tuner);
int v4l2_model_s_tuner(struct file *file, void *fd,
            const struct v4l2_tuner *tuner);

int v4l2_model_ioctl_g_aviinfoframe(struct file *file, U8_T *aviinfo);

int v4l2_model_ioctl_g_vendorinfoframe(struct file *file, U8_T *vendorinfo);

int v4l2_model_ioctl_g_audioinfoframe(struct file *file, U8_T *audioinfo);

int v4l2_model_ioctl_s_bypassmode(struct file *file, int *bypass_disable);

int v4l2_model_ioctl_s_pixelformat(struct file *file, int *pixel_format);

int v4l2_model_ioctl_g_hdcp(struct file *file, int *hdcp_flag);

int v4l2_model_ioctl_g_ITU(struct file *file, int *ITU_flag);

int v4l2_model_ioctl_g_audiorate(struct file *file, int *audio_rate);

#endif /* V4L2_MODEL_IOCTL_H_ */
